﻿package  
{
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class CrazyCritter extends Sprite
	{
		
		private var _width:Number;
		private var _height:Number;
				
		private var loader:Loader;
		private var movie:MovieClip;
		
		private var isLoaded:Boolean;
		
		public function CrazyCritter(width:Number,height:Number) 
		{
			_width = width;
			_height = height;
			
			loader = new Loader();
			
			loader.load(new URLRequest("character.swf"));
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoaded);
			
			isLoaded = false;
			
		}
		
		private function onLoaded(e:Event):void 
		{
			isLoaded = true;
			this.addChild(loader);
			movie = loader.content as MovieClip;
			loader.scaleX = 2;
			loader.scaleY = 2;
			loader.x = _width / 2-loader.width/2;
			loader.y = _height / 2-loader.height/2;
		}
		public function displayEnergy(percent:Number,isSleeping:Boolean):void
		{
			if (isLoaded)
			{
				if (isSleeping)
				{
					movie.gotoAndStop(movie.totalFrames);
				}else
				{
					movie.gotoAndStop(movie.totalFrames-Math.floor(movie.totalFrames*percent));
				}
				
			}
		}
		
	}
	
}
