﻿package  
{
	import flash.display.GradientType;
	import flash.display.Sprite;
	import flash.geom.Matrix;
	import flash.geom.Point;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class GradientBar extends Bar
	
	{

		
		public function GradientBar(width:Number,height:Number) 
		{
			super(width, height);
		}

		protected override function drawBar(val:Number ):void
		{
			this.graphics.clear();
			var colour:Number = 0xFF0000;
			var red:Number = 0;
			var blue:Number = 0;
			var green:Number = 0;
			
			if (val > .5)
			{
				green = 255;
				red = 255-(((val * 2) - 1) * 255);
			}else
			{
				green = (val * 2) * 255;
				red = 255;
			}
			
			colour = red << 16 | green << 8 | blue;
			var gradient:Number = 100;
			var secColour:Number = Math.max(0,red-gradient) << 16 | Math.max(0,green-gradient) << 8 | blue;
		
			//the type of gradient (other values is RADIAL)
			var fillType:String = GradientType.LINEAR;
			//The colours from the start to the end
			var colours:Array = [colour, secColour];
			//the alphas from the start to the end
			var alphas:Array = [1, 1];
			//Where the colours start and end, 0x00 means starts at the left edge and ends in at 0xFF which is at the right edge
			var ratios:Array = [0x00, 0xFF];
			//the matrix to transform the gradient - in our case rotate it.
			var matr:Matrix = new Matrix();
			//rotations is in radians..
			//createGradientBox(width,height,rotation,tx,ty);
			matr.createGradientBox(_width, _height, Math.PI / 2, 0, 0);
			//put it all together
			this.graphics.beginGradientFill(fillType, colours, alphas, ratios, matr);  
			//draw
			this.graphics.drawRoundRect(0, 0, _width*val, _height,10);
		}
		
	}
	
}