﻿package  
{
	
	/**
	* ...
	* @author DefaultUser (Tools -> Custom Arguments...)
	*/
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.ColorMatrixFilter;
	

	
	public class ColourWash extends Sprite
	{

		[Embed(source = "img/eagle.jpg")] 
		private var eagleImage:Class;
		
		private var image:Bitmap;
		
		private var destinationRed:Number;
		private var destinationGreen:Number;
		private var destinationBlue:Number;

		private var currentRed:Number;
		private var currentGreen:Number;
		private var currentBlue:Number;
		
		private var initialRed:Number;
		private var initialGreen:Number;
		private var initialBlue:Number;
		
		private const speed:Number = .02;
		
		public function ColourWash() 
		{
			image = new eagleImage();
			this.addChild(image);
			generateNewDestination();
			
					
			initialRed = 1;
			initialGreen = 1;
			initialBlue = 1;
			
			currentRed = initialRed;
			currentGreen = initialGreen;
			currentBlue = initialBlue;
			
			
			this.addEventListener(Event.ENTER_FRAME, animate);

			
		}
		
		private function generateNewDestination():void
		{
			destinationRed = Math.random();
			destinationGreen = Math.random();
			destinationBlue = Math.random();
			
			initialRed = currentRed;
			initialGreen = currentGreen;
			initialBlue = currentBlue;
		}
		
		private function animate(e:Event):void 
		{
		
			currentRed += (destinationRed-initialRed) * speed;
			currentGreen += (destinationGreen-initialGreen) * speed;
			currentBlue += (destinationBlue-initialBlue) * speed;
			
			var matrix:Array = new Array();
            matrix = matrix.concat([currentRed, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, currentGreen, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, currentBlue, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters;
			
			//all 3 colours will end at same time
			if ((destinationRed>initialRed&&currentRed >= destinationRed)||(destinationRed<initialRed&&currentRed <= destinationRed))
			{
				
				generateNewDestination();
			}
		}
		
		
		
		
		
	}
	
}
