﻿package 
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.filters.ColorMatrixFilter;
	
	
	public class Main extends Sprite
	{
		
		[Embed(source = "img/eagle.jpg")] 
		private var eagleImage:Class;
		
		[Embed(source = "img/rainbow.jpg")] 
		private var rainbowImage:Class;
		
		private var image:Bitmap;
		private var origImage:Bitmap;
		
		public function Main():void
		{
			
			//image = new eagleImage();
			image = new rainbowImage();
			origImage = new rainbowImage();
			
			image.y = 300;
			
			this.addChild(image);
			this.addChild(origImage);
			
			//desaturate();
			//negative();
			//changeBrightness(.3);
			bluetored();
		}
		
		/** No change to the image **/
		private function nochange():void
		{
			var matrix:Array = new Array();
            matrix = matrix.concat([1, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, 1, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, 1, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters
		}
		private function bluetored():void
		{
			var matrix:Array = new Array();
            matrix = matrix.concat([1, 0, 1, 0, 0]); // red
            matrix = matrix.concat([0, 1, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, 0, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters
		}
		
		private function redtoblue():void
		{
			var matrix:Array = new Array();
            matrix = matrix.concat([0, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, 1, 0, 0, 0]); // green
            matrix = matrix.concat([1, 0, 1, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters
		}
		
		/** Make a digital negative of the image **/
		private function negative():void
		{
			var matrix:Array = new Array();
            matrix = matrix.concat([1, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, 1, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, 1, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters;
		}
		
		/** Scale between 0 and 1 will darken image above 1 will brighten image, 1 is normal **/
		private function changeBrightness(scale:Number):void
		{
			var matrix:Array = new Array();
            matrix = matrix.concat([scale, 0, 0, 0, 0]); // red
            matrix = matrix.concat([0, scale, 0, 0, 0]); // green
            matrix = matrix.concat([0, 0, scale, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters;
		}
		
		private function desaturate():void
		{
			
			//values here depend on monitors. For more information look at luminance vectors
			var rwgt:Number = 0.3333;
			var gwgt:Number = 0.3333;
			var bwgt:Number = 0.3333;
			
			var matrix:Array = new Array();
            matrix = matrix.concat([rwgt, rwgt, rwgt, 0, 0]); // red
            matrix = matrix.concat([gwgt, gwgt, gwgt, 0, 0]); // green
            matrix = matrix.concat([bwgt, bwgt, bwgt, 0, 0]); // blue
            matrix = matrix.concat([0, 0, 0, 1, 0]); // alpha
			
			var filter:ColorMatrixFilter = new ColorMatrixFilter(matrix);
            var filters:Array = new Array();
            filters.push(filter);
            image.filters = filters
		}
	}
}