﻿package au.com.koali.paralax {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Loader;
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.filters.BlurFilter;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.net.URLRequest;
	
	/**
	* ...
	* @author Default
	*/
	public class Layer extends MovieClip{
		
		private var _speed:Number;
		private var imageLoader:Loader
		private var _imageWidth:Number;
		private var blurFilter:BlurFilter;

		public function Layer(image:String) {
		
			imageLoader = new Loader();
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageLoad);
			imageLoader.load(new URLRequest(image));
			
			imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, allLoaded);
			
		}
		
		private function allLoaded(e:Event):void 
		{
			trace("loaded");
		}
		
		private function onImageLoad(e:Event):void {
			var bitmapData:BitmapData = new BitmapData(imageLoader.width, imageLoader.height,true,0x00000000);
			var bitmapData2:BitmapData = new BitmapData(imageLoader.width, imageLoader.height,true,0x00000000);
			var bitmapData3:BitmapData = new BitmapData(imageLoader.width, imageLoader.height,true,0x00000000);
			
			bitmapData.draw(imageLoader);
			var bitmap:Bitmap = new Bitmap(bitmapData);
			
			bitmapData2.draw(bitmap);
			bitmapData3.draw(imageLoader);
			
			var bitmap2:Bitmap = new Bitmap(bitmapData2);
			var bitmap3:Bitmap = new Bitmap(bitmapData3);
			
			bitmap2.x = imageLoader.width;
			bitmap3.x = imageLoader.width*2;
			this.addChild(bitmap);
			this.addChild(bitmap2);
			this.addChild(bitmap3);
			_imageWidth = imageLoader.width;
			
		}
		
		
		public function get speed():Number { return _speed; }
		
		public function set speed(value:Number):void {
			_speed = value;
		}
		
		public function get imageWidth():Number { return _imageWidth; }
		
	
		
	}
	
}