﻿package  
{
	import flash.display.Shape;
	
	/**
	* ...
	* @author Carly Gooch
	*/
	public class Star extends Shape
	{
		
		public function Star() 
		{
			
		}
		//math from essential actionscript 3 
		public function draw(colour:Number = 0xFFFF00,numTips:int = 5, innerRadius:Number = 25, outerRadius:Number = 50,angle:Number = 0 ):void
		{
			this.graphics.lineStyle(1, colour, 1);
			
			if (numTips > 2)
			{
				var centerX:Number = outerRadius;
				var centerY:Number = outerRadius;
				var step:Number, halfStep:Number, startAngle:Number, dx:Number, dy:Number;
				
				step = (Math.PI * 2) / numTips;
				halfStep = step / 2;
				
				//convert angle to radians
				startAngle = (angle / 180) * Math.PI
				
				dx = centerX + (Math.cos(startAngle) * outerRadius);
				dy = centerY - (Math.sin(startAngle) * outerRadius);
				
				this.graphics.moveTo(dx, dy);
				
				for (var i:int = 1; i <= numTips; i++)
				{
					dx = centerX + Math.cos(startAngle + (step * i) - halfStep) * innerRadius;
					dy = centerY - Math.sin(startAngle + (step * i) - halfStep) * innerRadius;
					

					this.graphics.lineTo(dx, dy);
					
					dx = centerX + Math.cos(startAngle + (step * i)) * outerRadius;
					dy = centerY - Math.sin(startAngle + (step * i)) * outerRadius;

					this.graphics.lineTo(dx, dy);
				}
					
			}			
		}
	}
	
}